/*
 *	MIMeWave data viewer
 *
 *	"main.c"
 *
 *		Version 1.00	June 13, 1995
 *
 *		Copyright (C) 1995 by Sony Computer Entertainment Inc.
 *		All Rights Reserved.
 */

#include <sys/types.h>

#include <libetc.h>		/* for Control Pad
				/* PADg߂ɃCN[hKv */
#include <libgte.h>		/* LIBGS uses libgte
				/* LIGSg߂ɃCN[hKv*/
#include <libgpu.h>		/* LIBGS uses libgpu
				/* LIGSg߂ɃCN[hKv */
#include <libgs.h>		/* for LIBGS
				/* OtBbNCu g߂
				   \̂Ȃǂ`Ă */

#include "nmime.h"
#include "control.h"
#include "addr.h"		/* data addresses  */
#include "wave.h"

/* define when using normal MIMe */
/* #define NORMALMIME */

/* define when using 640x480 mode */
/* undefine when using 640x240 mode */
/*#define HIRESOLUTION*/

/* viewmode */
#define VIEW_FP 0		/* Replay frame by frame  /* R} */
#define VIEW_BP 1		/* Reverse frame by frame /* tR} */
#define VIEW_ONETIME 2		/* Replay once /* 1Vbg */
#define VIEW_REPEAT 3		/* Repeat /* JԂ */

#define OBJECTMAX 100		/* Maximum number of objects
                                /* 3D̃f͘_IȃIuWFNg
                                   B̍ő吔` */
   
#define OT_LENGTH  12		/* bit length of OT
                                /* I[_Oe[ủ𑜓x */

GsOT            Wot[2];		/* Uses two handlers of OTs for double buffering
                                /* I[_Oe[unhA
				   _uobt@̂߂QKv */

GsOT_TAG	zsorttable[2][1<<OT_LENGTH]; /* Area of two OTs
                                             /* I[_Oe[u */

GsDOBJ5		object[OBJECTMAX]; /* Array of object handlers
                                   /* IuWFNgnhA
				      IuWFNg̐Kv */

u_long          Objnum;		/* Number of objects
                                /* fOf[^̃IuWFNg̐ێ */

GsCOORDINATE2   DWorld;		/* Coordinate for GsDOBJ5
				/* IuWFNgƂ̍Wn */

SVECTOR         PWorld;	/* work area for making Coordinate parameter
                        /* Wn邽߂̃[e[VxN^[ */

extern MATRIX GsIDMATRIX;	/* Unit Matrix /* Pʍs */

GsRVIEW2  view;			/* View Point Handler
                                /* _ݒ肷邽߂̍\ */
GsF_LIGHT pslt[3];		/* Flat Lighting Handler
                                /* sݒ肷邽߂̍\ */
u_long padd, oldpadd;		/* Pad status buffers
                                /* Rg[̃f[^ێ */

/* Work area for packets
/* pPbgf[^쐬邽߂̃[N_uobt@̂2{Kv */
u_long PacketArea[0x10000]; 

/*#define PACKETBUF  0x80100000*/

/*u_long *PacketArea;*/

/* Transfer Function for smooth control */
extern int cntrlarry[CTLMAX][CTLTIME]; 
extern CTLFUNC ctlfc[CTLMAX];

/* Data tables for Transfer Functions */
static int cnv0[16] = {
	  39,  79, 118, 197, 315, 394, 433, 473,
	 473, 433, 394, 315, 197, 118,  79,  39
};

static int cnv1[24] = {
	 200, 325, 450, 475, 500, 475, 450, 375,
	 300, 250, 200, 150, 100,  80,  55,   0,
	 -50, -75,-100, -70, -40, -25, -10,  -5
};

static int cnv2[32] = {
	  20,  30,  40,  50,  59,  79,  98, 128,
	 157, 177, 197, 206, 216, 226, 236, 238,
	 236, 226, 216, 206, 197, 177, 157, 128,
	  98,  79,  59,  50,  40,  30,  20,  10
};

u_long *SCRATCH  = (u_long *)0x1f800000;

/************* MAIN START ******************************************/
main()
{
    u_long  fn;					/* frame (field) No. */
    int     i,j;
    u_long  cnt=0;
    int still;
    int viewmode;
    GsDOBJ5 *op;				/* pointer of Object Handlers
						/* IuWFNgnhւ̃|C^ */
    int     outbuf_idx;				/* double buffer index */
    MATRIX  tmpls;
    WAVE wave; 
#define WAVEMAX 16
    static WAVE_PR wp[WAVEMAX];

  
    ResetCallback();
    PadInit(1);
    /*  PacketArea = (u_long *)PACKETBUF;*/
    init_all();
    /*== initialize Transfer Function  ====*/

    init_cntrlarry(cnv1,24);
    /* initialize MIMe function */

#ifdef NORMALMIME
    init_mime_data(0, MODEL_ADDR, MDFDATAVTX, MDFDATANRM, ORGVTXBUF, ORGNRMBUF);
#else /* !NORMALMIME */
    init_mime_data(0, MODEL_ADDR, MDFDATAVTX, NULL, ORGVTXBUF, NULL);
#endif /* !NORMALMIME */

    for (i=0; i<MIMEMODELMAX; i++){
	for (j=0; j<MIMEMAX; j++){
	    mimepr[i][j]=0;
	}
    }


    /* Initialize object position */
    DWorld.coord.t[2] = -30000; 
    PWorld.vy = ONE/2;
    PWorld.vx = -ONE/12;

    wave_init(&wave, &wp[0], WAVEADDR, WAVE_REPEAT);
    viewmode=VIEW_REPEAT;
    still=0;

    for (fn=0;;fn++){
      	obj_interactive();			/* set motion data by pad data */

	set_cntrl(fn);				/* generate control wave by transfer function */	

	PWorld.vx += ctlfc[5].out;		/* Rotate around the X axis */
	PWorld.vy += ctlfc[4].out;		/* Rotate around the Y axis */
	PWorld.vz += ctlfc[3].out;		/* Rotate around the Z axis */
	DWorld.coord.t[2] += ctlfc[8].out;	/* Move along the Z axis */
	DWorld.coord.t[0] += ctlfc[6].out;	/* Move along the X axis */
	DWorld.coord.t[1] += ctlfc[7].out;	/* Move along the Y axis */


	switch (viewmode){
	  case VIEW_REPEAT:			/* repeat mode */
	    KanjiFntPrint("repeat mode\n");
	    if (padd&PADk & ~oldpadd){
		if (still){			/* go next mode (replay by frame) */
		    viewmode=VIEW_ONETIME;
		    wave.repeat=WAVE_NOREPEAT;
		    cnt=wave.s;
		    still=1;
		    break;
		} else{				/* still */
		    still=1;
		}
	    }
	    if (padd&PADh & ~oldpadd){
		still=0;
	    } else{
		if (!still) cnt++;
	    }
	    break;
	  case VIEW_ONETIME:			/* replay once mode */
	    KanjiFntPrint("one time mode\n");
	    if (padd&PADk & ~oldpadd){
		if (still){			/* go next mode (replay by frame) */
		    viewmode=VIEW_FP;
		    wave.repeat=WAVE_REPEAT;
		    still=1;
		    break;
		} else{
		    still=1;			/* still */
		}
	    }
	    if (padd&PADh & ~oldpadd){
		still=0;
		if (cnt>=wave.length) cnt=0;
	    } else{
		if (!still) cnt++;
		if (cnt>=wave.length) still=1;
	    }
	    break;
	  case VIEW_FP:				/* replay by frame mode */
	    KanjiFntPrint("still (forward) mode\n");
	    if (padd&PADk & ~oldpadd){		/* go next mode (reverse by frame) */
		viewmode=VIEW_BP;
		wave.repeat=WAVE_REPEAT;
		still=1;
		break;
	    }
	    if (padd&PADh & ~oldpadd){
		cnt++;
	    }
	    break;
	  case VIEW_BP:				/* reverse by frame mode */
	    KanjiFntPrint("still (backward) mode\n");
	    if (padd&PADk & ~oldpadd){		/* go next mode (repeat) */
		viewmode=VIEW_REPEAT;
		wave.repeat=WAVE_REPEAT;
		still=1;
		break;
	    }
	    if (padd&PADh & ~oldpadd){
		cnt--;
	    }
	    break;
	  default:
	    viewmode=VIEW_REPEAT;		/* go default mode */
	    wave.repeat=WAVE_REPEAT;
	    cnt=0;
	}
	if (cnt<0) cnt+=wave.length;

	waveset(&wave, cnt);

	KanjiFntPrint("%6d/%d\n",wave.s, wave.length);
	for (i=0; i<wave.num; i++){
	    if (wave.wp[i].size>0) mimepr[0][i]=wavepr(&wave,i);
	}
	if (still) KanjiFntPrint("press START\n");


	vertex_mime(0);				/* MIMe operation (Vertex) */
#ifdef NORMALMIME
	normal_mime(0);				/* MIMe operation (Normal) */
#endif /* NORMALMIME */

	GsSetRefView2(&view);			/* Calculate World-Screen Matrix
						/* [hXN[}gbNXvZ */
	outbuf_idx=GsGetActiveBuff();		/* Get the double buffer index
						/* _uobt@̂ǂ炩𓾂 */

	GsClearOt(0,0,&Wot[outbuf_idx]);	/* Clear OT
						/* I[_Oe[uNA */

	for (i=0,op=object;i<Objnum;i++){
	    /* Calculate Local-World Matrix
	    /* [h^[J}gbNXvZ */
	    GsGetLw(op->coord2,&tmpls);
	    
	    /* Set LWMATRIX to GTE Lighting Registers
	    /* Cg}gbNXGTEɃZbg */
	    GsSetLightMatrix(&tmpls);
	    
	    /* Calculate Local-Screen Matrix
	    /* XN[^[J}gbNXvZ */
	    GsGetLs(op->coord2,&tmpls);
	    
	    /* Set LSAMTRIX to GTE Registers
	    /* XN[^[J}gbNXGTEɃZbg */
	    GsSetLsMatrix(&tmpls);
	    
	    /* Obtain perspective projection and register it in OT
	    /* IuWFNg𓧎ϊI[_Oe[uɓo^ */
	    GsSortObject5(op,&Wot[outbuf_idx],14-OT_LENGTH,SCRATCH);
	    op++;
	}
	
#ifndef HIRESOLUTION
	DrawSync(0);
#endif /* !HIRESOLUTION */
	VSync(0);				/* Wait VSYNC /* VuN҂ */
	oldpadd=padd;
	padd=PadRead(1);			/* Reading control pad data
						/* pbh̃f[^ǂݍ */
	ResetGraph(1);
	GsSwapDispBuff();			/* Swap double buffer
						/* _uobt@ؑւ */
      
	/* Set SCREEN CLEAR PACKET to top of OT
	/* ʂ̃NAI[_Oe[u̍ŏɓo^ */
	GsSortClear(0x0,0x0,0x0,&Wot[outbuf_idx]);
      
	/* Start drawing packets on OT
	/* I[_Oe[uɓo^ĂpPbg̕`Jn */
	GsDrawOt(&Wot[outbuf_idx]);
	KanjiFntFlush(-1);			/* draw print-stream */
    }
}


obj_interactive()
{
  SVECTOR v1;
  MATRIX  tmp1;

/*=============================================================================*/ 


  		/* set control data4 for rotation of Z axis */
		if((padd & PADm)>0) 	 ctlfc[3].in =  ONE/128;
		else {  if((padd & PADl)>0) ctlfc[3].in = -ONE/128; 
			else 			 ctlfc[3].in =      0; 
		}
  		/* set control data4 for rotation of Y axis */
		if((padd & PADRleft)>0) 	 ctlfc[4].in =  ONE/64;
		else {  if((padd & PADRright)>0) ctlfc[4].in = -ONE/64; 
			else 			 ctlfc[4].in =      0; 
		}
  		/* set control data5 for rotation of X axis */
		if((padd & PADRup)>0) 		 ctlfc[5].in =  ONE/64;
		else { 	if((padd & PADRdown)>0)  ctlfc[5].in = -ONE/64;
			else			 ctlfc[5].in =      0; 
		}
  		/* set control data8 for motion along Z axis */
		ctlfc[8].in =   0; 
		if((padd & PADo)>0)		 ctlfc[8].in += -240;
		if((padd & PADn)>0)	 ctlfc[8].in +=  240; 

  		/* set control data6 for motion along X axis */
		if((padd & PADLleft)>0) 	 ctlfc[6].in =  180;
		else {  if((padd & PADLright)>0) ctlfc[6].in = -180; 
			else			 ctlfc[6].in =   0; 
		}
  		/* set control data7 for motion along Y axis */
		if((padd & PADLup)>0)		 ctlfc[7].in = -180;
		else {  if((padd & PADLdown)>0)	 ctlfc[7].in =  180;
			else			 ctlfc[7].in =   0; 
		}
/*=============================================================================*/ 
  if(((padd & PADk)>0)&&((padd & PADo)>0)&&((padd & PADm)>0)) 
	{PadStop(); StopCallback(); ResetGraph(1); exit();}
 
  /* set matrix in the coordinate system  */
  set_coordinate(&PWorld,&DWorld);
  
  /* clear flag for recalcuration */
  DWorld.flg = 0;
}



/* Initialize routines
/* [`Q */
init_all()
{
  ResetGraph(0);		/* Reset GPU /* GPUZbg */
  padd=0;			/* Initialize pad data /* Rg[l */

#ifdef HIRESOLUTION
  GsInitGraph(640,480,GsOFSGPU|GsINTER,1,0); /* resolution set, interlace mode*/
  GsDefDispBuff(0,0,0,0);	/* Set double buffer */
#else /* !HIRESOLUTION */
  GsInitGraph(640,240,GsOFSGPU|GsINTER,1,0); /* resolution set, interlace mode*/
  GsDefDispBuff(0,0,0,240);	/* Set double buffer */
#endif /* !HIRESOLUTION */
    

  GsInit3D();			/* Initialize 3D system /* 3DVXe */

  Wot[0].length=OT_LENGTH;	/* Set bit length of OT handler
                                /* I[_Oe[unhɉ𑜓xݒ */
  Wot[0].org=zsorttable[0];	/* Set top address of OT Area to OT handler
                                /* I[_Oe[unh
				   I[_Oe[u̎̐ݒ */

  /* same setting for the other OT handler
  /*_uobt@̂߂ɂݒ */
  Wot[1].length=OT_LENGTH;
  Wot[1].org=zsorttable[1];
  coord_init();			/* Initialize coordinate /* W` */
  model_init();			/* Read model data /* fOf[^ǂݍ */  
  view_init();			/* Set view point  /* _ݒ */
  light_init();			/* Set Flat Light  /* sݒ */

/*  FntLoad(960, 256);				/* font load */
/*  SetDumpFnt(FntOpen(-290,-200,400,100,0,200)); /* stream open & define */

/*	KanjiFntOpen(160, 16, 256, 200, 704, 0, 768, 256, 0, 512);*/
#ifdef HIRESOLUTION
  KanjiFntOpen(-300, -205, 400, 100, 960, 256, 512, 511, 0, 256);
#else /* !HIRESOLUTION */
  KanjiFntOpen(-300, -110, 400, 100, 960, 256, 512, 511, 0, 256);
#endif /* !HIRESOLUTION */
  initTexture(TEXTURE_ADDR);
}


view_init()			/* Set view point /* _ݒ */
{
  GsSetProjection(1000);	/* Set projection /* vWFNVݒ */
  
  /* Set view point location /* _p[^ݒ */
  view.vpx = 0; view.vpy = 0; view.vpz = 2000;
  
  /* Set focus point location /* _p[^ݒ */
  view.vrx = 0; view.vry = 0; view.vrz = 0;
  
  /* Set bank of SCREEN /* _̔Pp[^ݒ */
  view.rz=0;

  /* Set parent of viewing coordinate /* _Wp[^ݒ */
  view.super = WORLD;
  
  /* Calculate World-Screen Matrix from viewing parameter
  /* _p[^Q王_ݒ肷郏[hXN[}gbNXvZ */
  GsSetRefView2(&view);
  
  GsSetNearClip(100);           /* Set Near Clip /* jANbvݒ */
}


light_init()			/* Initialize Flat Light /* sݒ */
{
  /* Set Light ID 0 /* CgID 0 ݒ */
  /* Set direction vector of Light0 /* sp[^ݒ */
  pslt[0].vx = 20; pslt[0].vy= 100; pslt[0].vz= -100;
  
  /* Set color of Light0 /* sFp[^ݒ */
  pslt[0].r=0xd0; pslt[0].g=0xd0; pslt[0].b=0xd0;
  
  /* Set Light0 from parameters /* p[^ݒ */
  GsSetFlatLight(0,&pslt[0]);

  
  /* Set Light ID 1 /* CgID 1 ݒ */
  pslt[1].vx = 20; pslt[1].vy= 50; pslt[1].vz= 100;
  pslt[1].r=0x80; pslt[1].g=0x80; pslt[1].b=0x80;
  GsSetFlatLight(1,&pslt[1]);
  
  /* Set Light ID 2 /* CgID 2 ݒ */
  pslt[2].vx = -20; pslt[2].vy= -20; pslt[2].vz= -100;
  pslt[2].r=0x60; pslt[2].g=0x60; pslt[2].b=0x60;
  GsSetFlatLight(2,&pslt[2]);
  
  /* Set Ambient /* ArGgݒ */
  GsSetAmbient(512,512,512);

  /* Set default light mode /* vZ̃ftHg̕ݒ */
  GsSetLightMode(0);
}


coord_init()			/* Set coordinate /* Wnݒ */
{
  /* Set hierarchy of Coordinate /* W̒` */
  GsInitCoordinate2(WORLD,&DWorld);
  
  /* Initialize work vector
  /* }gbNXvZ[Ñ[e[VxN^[ */
  PWorld.vx=PWorld.vy=PWorld.vz=0;
  
  /* Set the orgin of DWold to Z = -4000
  /* IuWFNǧ_[hZ = -4000ɐݒ */
  DWorld.coord.t[2] = -4000;
}


/* Set coordinate parameter from work vector
/* [eVxN^}gbNX쐬WnɃZbg */
set_coordinate(pos,coor)
SVECTOR *pos;			/* work vector for rotation /* [eVxN^ */
GsCOORDINATE2 *coor;		/* Coordinate system /* Wn */
{
  MATRIX tmp1;
  SVECTOR v1;
  
  tmp1   = GsIDMATRIX;		/* start from unit matrix /* Pʍs񂩂o */
    
  /* Set translation /* sړZbg */
  tmp1.t[0] = coor->coord.t[0];
  tmp1.t[1] = coor->coord.t[1];
  tmp1.t[2] = coor->coord.t[2];
  
  /* Set rotation vector to a work area
  /* }gbNX[NɃZbgĂ郍[e[V[ÑxN^[ɃZbg */
  v1 = *pos;
  
  /* Rotate the Matrix
  /* }gbNXɃ[e[VxN^p */
  RotMatrix(&v1,&tmp1);
  
  /* Set the Matrix to Coordinate
  /* ߂}gbNXWnɃZbg */
  coor->coord = tmp1;

  /* Clear the cache flag
  /* }gbNXLbVtbV */
  coor->flg = 0;
}

/* Load texture data to VRAM /* eNX`f[^VRAMɃ[h */
initTexture(u_long *addr)
{
#define TIM_ID 0x10
    RECT rect1;
    GsIMAGE tim1;
    u_short *ap;

    while (*addr == TIM_ID){			/* texture data exists */
	addr++;

	/* Get TIM info /* TIMf[^̏𓾂 */	
	GsGetTimInfo(addr, &tim1);

	/* Load CLUT to VRAM if exists /* CLUTꍇVRAM֑ */	
	if((tim1.pmode>>3)&0x01) {
	    rect1.x=tim1.cx;
	    rect1.y=tim1.cy;
	    rect1.w=tim1.cw;
	    rect1.h=tim1.ch;
	    LoadImage(&rect1,tim1.clut);
	    addr += tim1.cw*tim1.ch/2+3;
	}
	/* Load pixel data to VRAM /* sNZf[^VRAM֑ */	
	rect1.x=tim1.px;
	rect1.y=tim1.py;
	rect1.w=tim1.pw;
	rect1.h=tim1.ph;
	LoadImage(&rect1,tim1.pixel);
/*	addr += tim1.pw * tim1.ph/2+3+1;*/	/* next texture pointer */
	ap = (u_short*)(addr+1);
	ap += tim1.pw*tim1.ph+6;
	addr = (u_long*)ap;			/* next texture pointer */
    }
}

#if 0
texture_init(addr)
u_long addr;
{
  RECT rect1;
  GsIMAGE tim1;

  /* Get texture information from TIM header
  /* TIMf[^̃wb_eNX`̃f[^^Cv̏𓾂 */  
  GsGetTimInfo((u_long *)(addr+4),&tim1);
  
  rect1.x=tim1.px;		/* X of image data on VRAM
				/* eNX`VRAMłXW */
  rect1.y=tim1.py;		/* Y of image data on VRAM
				/* eNX`VRAMłYW */
  rect1.w=tim1.pw;		/* Width of image /* eNX` */
  rect1.h=tim1.ph;		/* Height of image /* eNX` */
  
  /* Load texture to VRAM /* VRAMɃeNX`[h */
  LoadImage(&rect1,tim1.pixel);
  
  if((tim1.pmode>>3)&0x01)	/* Color Lookup Table found 
				/* J[bNAbve[u݂ */  
    {

      rect1.x=tim1.cx;		/* X of CLUT data on VRAM
				/* NbgVRAMłXW */
      rect1.y=tim1.cy;		/* Y of CLUT data on VRAM
				/* NbgVRAMłYW */
      rect1.w=tim1.cw;		/* Width of CLUT /* Nbg̕ */
      rect1.h=tim1.ch;		/* Height of CLUT /* Nbg̍ */

      /* Load CULT data to VRAM /* VRAMɃNbg[h */
      LoadImage(&rect1,tim1.clut);
    }
}
#endif /* 0 */


/* Read model data (TMD FORMAT) /* fOf[^̓ǂݍ */
model_init()
{
  u_long *dop;
  GsDOBJ5 *objp;		/* handler of object
				/* fOf[^nh */
  int i;
  u_long *oppp;			/* packet area pointer */
  
  dop=(u_long *)MODEL_ADDR;	/* Top Address of MODEL DATA(TMD FORMAT)
				/* fOf[^i[ĂAhX */
  dop++;			/* Skip header */
  
  GsMapModelingData(dop);	/* Map TMD model on the real address 
				/* fOf[^iTMDtH[}bgj
				   AhXɃ}bv*/

  dop++;
  Objnum = *dop;		/* Get number of Objects
				/* IuWFNgTMD̃wb_瓾 */

  dop++;			/* Adjust for GsLinkObject2
				/* GsLinkObject2ŃN邽߂TMD
				   IuWFNg̐擪ɂĂ */

  /* Link TMD model to object handler one by one
  /* TMDf[^ƃIuWFNgnhڑ */
  for(i=0;i<Objnum;i++)
    GsLinkObject5((u_long)dop,&object[i],i);
  /* Top address of packet area /* packet̘ggAhX */
  oppp = PacketArea;
  
  for(i=0,objp=object;i<Objnum;i++)
    {	
      /* Set Coordinate of Object Handler
      /*ftHg̃IuWFNg̍Wn̐ݒ */
      objp->coord2 =  &DWorld;
      
      objp->attribute = 0;	/* Initialize attribute */
      
      /* Set PACKETS before using GsDOBJ5 
      /* GsDOBJ5^̃IuWFNg͗\߃pPbg̘gg
	 ȂΎgȂ */      
      oppp = GsPresetObject(objp,oppp);	
      
      objp++;
    }
}
